Subject: bug#67691: 29.1.50; Virtual buffers in fido-mode

From: bcclaro <[email-masked]>
Date: Fri, 8 Dec 2023 11:38:49 -0300

> Is a "closed buffer" a "killed buffer"?

Indeed. So the feature request would be to keep killed buffers as options
to switch to, the idea being that buffers recently used are more likely to
be opened than other buffers. The same idea motivates the recentf feature
request, the difference being that recent buffers might mean buffers that
were opened on a previous Emacs run.

This latter feature seems to subsume the former, but I don't know how the
actual implementation goes since I use fido-mode — I just felt like it
would be nice to have recent files and buffers as completion candidates to
commands like find-file and switch-to-buffer. Expanding on this, when I am
working on a project, I just use project-find-file to find files that are
not in the same directory my current buffer is in faster. But if I want to
edit a configuration file somewhere, or a file in /tmp, it takes longer to
find it, which is something I'm hoping this feature will help alleviate.

> Maybe this feature (and also the preceding one, I guess) could be
> argued for in terms of changes to Emacs's completion frontend
> so that it is available to fido, icomplete, vanilla completion,
> and maybe more.

Yes, that makes sense to me.

> So including files in a buffer list?  Seems odd, but then ido had a lot
of oddities.

> So, if I were to work on something for Fido, it would be that
> feature (which, importantly, doesn't mix buffers with files in
> the same bag).

It is indeed. The feature you describe would make me happy; if I killed the
buffer for a file I wouldn't mind find-file'ing the file again if I had
this feature to help.

On Fri, 8 Dec 2023 at 10:23, João Távora <[email-masked]> wrote:

> On Fri, Dec 8, 2023 at 12:29 PM Dmitry Gutov <[email-masked]> wrote:
> >
> > On 08/12/2023 13:27, João Távora wrote:
> > >> Also somewhat relevant, from the same question:
> > >>
> > >>> Is there a way to get recentf entries to be appended after the open
> > >>> buffers when I call switch-to-buffer using fido-vertical-mode?
> > >> I'm not the OP but I was in need of much the same functionality.
> > > Maybe this feature (and also the preceding one, I guess) could be
> > > argued for in terms of changes to Emacs's completion frontend
> > > so that it is available to fido, icomplete, vanilla completion,
> > > and maybe more.  But I don't understand exactly what the
> > > feature does (though here it seems simpler than in the previous
> > > one).
> >
> > It's the same feature.
> >
> > I think ido-use-virtual-buffers's docstring has a good explanation.
> >
> > So, two parts:
> >
> > - Using entries from recentf in the list of buffers to switch to.
> > - Color them differently somehow.
>
> So including files in a buffer list?  Seems odd, but then ido
> had a lot of oddities.
>
> Anyway, I think what I miss most about Ido also solves the
> problem of going to recently visited files.  In Ido, I could
> ido-find-file, type a fragment of a file name and then M-p to
> cycle between those old files that match that pattern
>
> In vanilla completion, icomplete, etc (and this includes fido-mode),
> M-p doesn't do this search.  The workflow for this appears to be M-r
> for previous-matching-history-element but that asks me to input
> a regexp, which is not necessarily the completion style I have
> configured.  Even when I do that, it doesn't seem to work very well,
> doesn't seem to go into the recentf list, or at least is confusing
> enough that I don't bother trying it.  But I still miss that feature
> after many years away from Ido.
>
> So, if I were to work on something for Fido, it would be that
> feature (which, importantly, doesn't mix buffers with files in
> the same bag).
>
> João
>